import java.awt.*;
import javax.swing.*;

/**
 * A polynomial calculator
 * modified by edhong 1/11/06
 * @author TCSS 342
 * @version 1.0
 */

public class PolyCalc {

    private PolyCalcEngine engine;
    private PolyCalcUI gui;

    public PolyCalc() {
        //Construct the application
        engine = new PolyCalcEngine();
        gui = new PolyCalcUI(engine);
        JFrame frame = gui.getFrame();

        //Center the window
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
        gui.redisplay();
    }

    public static void main(String[] args) {
        PolynomialADT a = new LinkedPolynomial();
        PolynomialADT b = new LinkedPolynomial();
        PolynomialADT c = new LinkedPolynomial();

        a.zeroPolynomial();
        System.out.println ( "a = " + a );
        a.insertTerm(-3, 5);
        System.out.println ( "a = " + a );
        a.insertTerm(2, 1);
        System.out.println ( "a = " + a );
        a.insertTerm(-2, 3);
        System.out.println ( "a = " + a );
        a.insertTerm(-1, -5);
        System.out.println ( "a = " + a );
        a.insertTerm(8, 0);
        System.out.println ( "a = " + a );
        a.insertTerm(0, 1);
        System.out.println ( "a = " + a );
        b = a.derivative();
        System.out.println ( "b = " + b );
        c = a.plus(b);
        System.out.println ( "c = " + c );
        c = c.plus(a);
        System.out.println ( "c = " + c );
        c = c.minus(c);
        System.out.println ( "c = " + c );
        a.zeroPolynomial();
        System.out.println ( "a = " + a );

        new PolyCalc();
    }

}